unit MAIN_32;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,IniFiles,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, Spin, Grids,
  port_32, ComCtrls, Tabnotbk;

type
  TMainForm = class(TForm)
    TabbedNotebook1: TTabbedNotebook;
    Label5: TLabel;
    BitBtn3: TBitBtn;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    G_Read: TGroupBox;
    RPin1: TCheckBox;
    RPin2: TCheckBox;
    RPin3: TCheckBox;
    RPin4: TCheckBox;
    RPin5: TCheckBox;
    RPin6: TCheckBox;
    Rpin7: TCheckBox;
    RPin8: TCheckBox;
    RPin9: TCheckBox;
    RPin10: TCheckBox;
    RPin11: TCheckBox;
    RPin12: TCheckBox;
    RPin13: TCheckBox;
    RPin14: TCheckBox;
    RPin15: TCheckBox;
    RPin16: TCheckBox;
    RPin17: TCheckBox;
    GroupBox1: TGroupBox;
    WPin1: TCheckBox;
    WPin2: TCheckBox;
    WPin3: TCheckBox;
    WPin4: TCheckBox;
    WPin5: TCheckBox;
    WPin6: TCheckBox;
    WPin7: TCheckBox;
    WPin8: TCheckBox;
    WPin9: TCheckBox;
    WPin14: TCheckBox;
    WPin15: TCheckBox;
    WPin17: TCheckBox;
    Label6: TLabel;
    Timer1: TTimer;
    WPin10: TCheckBox;
    WPin11: TCheckBox;
    WPin12: TCheckBox;
    WPin13: TCheckBox;
    WPin16: TCheckBox;
    Label7: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    CheckBox16: TCheckBox;
    Label10: TLabel;
    B_Read: TButton;
    B_ReadAll: TButton;
    B_Write: TButton;
    B_WriteAll: TButton;
    GRead: TStringGrid;
    GWrite: TStringGrid;
    C_Hard: TCheckBox;
    VicLPT1: TVicLPT;
    Label8: TLabel;
    Label9: TLabel;
    HwCtrl: TVicPort;
    GroupBox2: TGroupBox;
    C_BUSY: TCheckBox;
    C_PE: TCheckBox;
    C_ERROR: TCheckBox;
    B_WriteAllPins: TButton;
    C_Init: TButton;
    B_Print: TButton;
    TextMemo: TMemo;
    B_Clear: TButton;
    B_Stop: TButton;
    procedure FormActivate(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure GReadSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure B_WriteClick(Sender: TObject);
    procedure B_WriteAllClick(Sender: TObject);
    procedure B_ReadClick(Sender: TObject);
    procedure B_ReadAllClick(Sender: TObject);
    procedure C_HardClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure C_INITClick(Sender: TObject);
    procedure C_StrobeClick(Sender: TObject);
    procedure B_WriteAllPinsClick(Sender: TObject);
    procedure B_ClearClick(Sender: TObject);
    procedure B_PrintClick(Sender: TObject);
    procedure B_StopClick(Sender: TObject);
  end;

const MaxPorts = 16;

var
  MainForm: TMainForm;
  PortWSel,PortRSel:Word;
  ValWSel:Byte;
  NomWSel,NomRSel:Byte;
  FlagPrint : Boolean;
  NumLine : Word;
  NumSymbol:Word;
implementation

var CPinRead,CPinWrite : array[1..25] of TCheckBox;

var PortRec : array[1..16] of record
                                  PortAddr : Word;
                                  PortData : Byte;
                                  fWrite   : Boolean;
                                end;
{$R *.DFM}

procedure ShowButtons;
begin
  with MainForm,HwCtrl do
  begin
   GroupBox1.Enabled:=ActiveHW;
   B_Write.Enabled:=ActiveHW;
   B_Read.Enabled:=ActiveHW;
   B_WriteAll.Enabled:=ActiveHW;
   B_ReadAll.Enabled:=ActiveHW;
  end;
end;

procedure TMainForm.FormActivate(Sender: TObject);
var MyIniFile : TIniFile;
    i         : Word;
begin

  if not HwCtrl.ActiveHW then
  begin
    MessageBeep(0);
    Application.MessageBox('Driver "VICPRTxx" not found',
                      ' Warning! ',mb_OK or mb_ICONHAND);
    Label6.caption:='Driver not opened';
  end
  else begin
         Timer1.Enabled:=TRUE;
         Label6.caption:='Driver opened';
         Label6.Font.Color:=clGreen;
//         for i:=1 to 17 do VicLPT1.Pin[i]:=FALSE;
       end;

 CPinRead[ 1]:=RPin1;    CPinWrite[ 1]:=WPin1;
 CPinRead[ 2]:=RPin2;    CPinWrite[ 2]:=WPin2;
 CPinRead[ 3]:=RPin3;    CPinWrite[ 3]:=WPin3;
 CPinRead[ 4]:=RPin4;    CPinWrite[ 4]:=WPin4;
 CPinRead[ 5]:=RPin5;    CPinWrite[ 5]:=WPin5;
 CPinRead[ 6]:=RPin6;    CPinWrite[ 6]:=WPin6;
 CPinRead[ 7]:=RPin7;    CPinWrite[ 7]:=WPin7;
 CPinRead[ 8]:=RPin8;    CPinWrite[ 8]:=WPin8;
 CPinRead[ 9]:=RPin9;    CPinWrite[ 9]:=WPin9;
 CPinRead[10]:=RPin10;   CPinWrite[10]:=WPin10; WPin10.Enabled:=FALSE;
 CPinRead[11]:=RPin11;   CPinWrite[11]:=WPin11; WPin11.Enabled:=FALSE;
 CPinRead[12]:=RPin12;   CPinWrite[12]:=WPin12; WPin12.Enabled:=FALSE;
 CPinRead[13]:=RPin13;   CPinWrite[13]:=WPin13; WPin13.Enabled:=FALSE;
 CPinRead[14]:=RPin14;   CPinWrite[14]:=WPin14;
 CPinRead[15]:=RPin15;   CPinWrite[15]:=WPin15; WPin15.Enabled:=FALSE;
 CPinRead[16]:=RPin16;   CPinWrite[16]:=WPin16;
 CPinRead[17]:=RPin17;   CPinWrite[17]:=WPin17;

 if GetVersion<0 then Label5.caption:='Detected: Windows 95'
                 else Label5.caption:='Detected: Windows NT';

 MyInifile:=TIniFile.Create('HW_test.ini');

 with MyIniFile,HwCtrl do
 begin
  for i:=1 to MaxPorts do
  begin
    with GWrite do
    begin
      Cells[0,i]:=IntToStr(i);
      Cells[1,0]:='PORT'; Cells[2,0]:='VAL';
      Cells[1,i]:=ReadString('PortW','Port'+IntToStr(i),'');
      Cells[2,i]:=ReadString('Values','Val'+IntToStr(i),'');
    end;
    with GRead do
    begin
      Cells[0,i]:=IntToStr(i);
      Cells[1,0]:='PORT'; Cells[2,0]:='VAL';
      Cells[1,i]:=ReadString('PortR','Port'+IntToStr(i),'');
    end;
  end;
  C_Hard.Checked:=HardAccess;
 end;
 MyIniFile.Free;
 ShowButtons;
// for i:=1 to 17 do VicLPT1.Pin[i]:=FALSE;
end;

procedure TMainForm.BitBtn3Click(Sender: TObject);
var MyIniFile : TIniFile;
    i         : Word;
begin
// for i:=1 to 17 do VicLPT1.Pin[i]:=FALSE;
 MyInifile:=TIniFile.Create('HW_test.ini');
 with MyIniFile,HwCtrl  do
 begin
  for i:=1 to MaxPorts do
  begin
    with GWrite do
    begin
      WriteString('PortW','Port'+IntToStr(i),Cells[1,i]);
      WriteString('Values','Val'+IntToStr(i),Cells[2,i]);
    end;
    with GRead do
    begin
      WriteString('PortR','Port'+IntToStr(i),Cells[1,i]);
    end;
  end;
 end;
 MyIniFile.Free;
 Timer1.Enabled:=FALSE;
 Close;
end;

function HexToInt(s:String):dWord;
const hexch:array[0..15] of Char='0123456789ABCDEF';
var i,j : Byte;
    r,n,k:dWord;
    ch : Char;
begin
  k:=1; r:=0;
  for i:=Length(s) downto 1 do
  begin
    ch:=s[i]; n:=0;
    for j:=0 to 15 do if UpperCase(ch)=hexch[j] then n:=j;
    r:=r+n*k; if i>1 then k:=k*16;
  end;
  Result:=r;
end;

procedure TMainForm.GReadSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
  with GRead do
  begin
    PortRSel:=HexToInt(Cells[1,Row]); NomRSel:=Row;
  end;
end;

procedure TMainForm.B_WriteClick(Sender: TObject);
begin
 with GWrite,HwCtrl do
 begin
   PortWSel:=HexToInt(Cells[1,Row]);    Cells[1,Row]:=IntToHex(PortWSel,4);
   ValWSel:=HexToInt(Cells[2,Row]);     Cells[2,Row]:=IntToHex(ValWSel,2);
   NomWSel:=Row;
   if (PortWSel=0) then begin MessageBeep(0); Exit; end;
   Port[PortWSel]    :=ValWSel;
 end;
end;
procedure TMainForm.B_WriteAllClick(Sender: TObject);
var i,v       : Byte;
    P,N       : Word;
begin
 with GWrite,HwCtrl do
 begin
   N:=0;
   for i:=1 to MaxPorts do
   begin
     P:=HexToInt(Cells[1,i]); Cells[1,i]:=IntToHex(P,4);
     if p>0 then
     begin
       V:=HexToInt(Cells[2,i]); Cells[2,i]:=IntToHex(v,2);
       Inc(N);
       PortRec[N].PortData:=V;
       PortRec[N].PortAddr:=P;
       PortRec[N].fWrite:=TRUE;
     end;
   end;
   if N>0 then PortControl(@PortRec,N);
 end;

 end;

procedure TMainForm.B_ReadClick(Sender: TObject);
var b : Byte;
begin
 with GRead,HwCtrl do
 begin
   PortRSel:=HexToInt(Cells[1,Row]); Cells[1,Row]:=IntToHex(PortRSel,4);
   NomRSel:=Row;
   if (PortRSel=0) then begin MessageBeep(0); Exit; end;
   b:=Port[PortRSel];
   Cells[2,Row]:=IntToHex(b,2);
 end;
end;

procedure TMainForm.B_ReadAllClick(Sender: TObject);
var i       : Byte;
    P,N     : Word;
    cl      : array[1..16] of Byte;
begin
 with GRead,HwCtrl do
 begin
   N:=0;
   for i:=1 to MaxPorts do
   begin
     P:=HexToInt(Cells[1,i]); Cells[1,i]:=IntToHex(P,4);
     if p>0 then
     begin
       Inc(N); cl[N]:=i;
       PortRec[N].PortAddr:=P;
       PortRec[N].fWrite:=FALSE;
     end;
   end;
   if N>0 then PortControl(@PortRec,N);
   for i:=1 to N do
     Cells[2,cl[i]]:=IntToHex(PortRec[i].PortData,2);
 end;
end;

procedure TMainForm.C_HardClick(Sender: TObject);
begin
  HwCtrl.HardAccess := C_Hard.Checked;
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
var nPin : Byte;
    s : String;
    i : Word;
begin
 with VicLPT1,TextMemo do
 begin
  for nPin:=1 to 17 do
    CPinRead[nPin].Checked:=Pin[nPin];
  C_BUSY.Checked :=BUSY;
  C_PE.Checked   :=PE;
  C_ERROR.Checked:=_ERROR;
  if FlagPrint then
  begin
    Timer1.Enabled:=FALSE;
    for i:=1 to 100 do
    begin
      Application.ProcessMessages;
      s:=Lines[NumLine]+#$0D#$0A;
      if NumSymbol>Length(s) then
      begin
        if NumLine=Lines.Count then begin
                                      Timer1.Enabled:=TRUE;
                                      FlagPrint:=FALSE; Exit;
                                    end;
        Inc(NumLine);
        s:=Lines[NumLine]+#$0D#$0A;
        NumSymbol:=1;
      end;
      if PrintChar(s[NumSymbol]) then Inc(NumSymbol);
    end;
    Timer1.Enabled:=TRUE;
  end;

  B_Stop.Enabled:=FlagPrint;
  B_Print.Enabled:=not FlagPrint;
 end; 
end;

procedure TMainForm.C_INITClick(Sender: TObject);
begin
  VicLPT1._INIT;
end;

procedure TMainForm.C_StrobeClick(Sender: TObject);
begin
  VicLPT1._STROBE;
end;

procedure TMainForm.B_WriteAllPinsClick(Sender: TObject);
var nPin:Byte;
begin
  for nPin:=1 to 17 do
   VicLPT1.Pin[nPin]:=CPinWrite[nPin].Checked;
end;

procedure TMainForm.B_ClearClick(Sender: TObject);
begin
  TextMemo.Clear;  
end;

procedure TMainForm.B_PrintClick(Sender: TObject);
begin
  with TextMemo,VicLPT1 do
  begin
    if FlagPrint then Exit;
    NumLine:=0;
    NumSymbol:=1;
    FlagPrint:=TRUE;
  end;
end;

procedure TMainForm.B_StopClick(Sender: TObject);
begin
  FlagPrint:=FALSE;
end;

initialization
  NomWSel:=0; NomRSel:=0;  FlagPrint:=FALSE;
end.
